;===============================================================
; "SERRA PELADA" - ZX-SPECTRUM TEXT ADVENTURE GAME IN PORTUGUESE
; "SERRA PELADA" - ADVENTURE TEXTO EM PORTUGUES PARA ZX-SPECTRUM
;===============================================================
; VERSAO ORIGINAL (MSX):  RENATO DEGIOVANI
; CONVERSAO ZX-SPECTRUM:  EINAR SAUKAS
;===============================================================

TABELA_REGISTRADORES EQU  (REG01_POS_ATUAL-1)
TABELA_PREPOSICOES   EQU  $70ad
COPY_SCREEN          EQU  $dc00
LOAD_BUFFER          EQU  $f700
INPUT_BUFFER         EQU  $f802

;===============================================================
; TABELA DE ENDERECO DE PROCESSAMENTO DAS INSTRUCOES
;===============================================================
        org     $6500
TABELA_INSTRUCOES:
        defw    INSTR_00_NOP
        defw    INSTR_01_PRINT_MSG
        defw    INSTR_02_EXIT
        defw    INSTR_03_EXIT_LIST_POS
        defw    INSTR_04_EXIT_LIST_PLAYER
        defw    INSTR_05_EXIT_LIST_CONTAINER
        defw    INSTR_06_PRINT_OBJ
        defw    INSTR_07_INC_REG
        defw    INSTR_08_DEC_REG
        defw    INSTR_09_SET_REG
        defw    INSTR_10_ADD_REG
        defw    INSTR_11_ADD_REG_RND
        defw    INSTR_12_IF_REG_EQUAL
        defw    INSTR_13_IF_REG_GREATER
        defw    INSTR_14_IF_REG_LOWER
        defw    INSTR_15_IF_OBJ_NEARBY
        defw    INSTR_16_IF_AT_POS
        defw    INSTR_17_IF_HAVE_OBJ
        defw    INSTR_18_DROP_OBJ
        defw    INSTR_19_GET_OBJ
        defw    INSTR_20_CREATE_OBJ
        defw    INSTR_21_BREAK_OBJ
        defw    INSTR_22_EXEC_FUNC
        defw    INSTR_23_OPEN_CONTAINER
        defw    INSTR_24_CLOSE_CONTAINER
        defw    INSTR_25_PUT_OBJ_CONTAINER
        defw    INSTR_26_DROP_ALL_CONTAINER
        defw    INSTR_27_EXIT_OK
        defw    INSTR_28_PRINT_REG
        defw    INSTR_29_EXIT_FUNC5
        defw    INSTR_30_EXIT_FUNC4
        defw    INSTR_31_EXIT_QUIT
        defw    INSTR_32_EXIT_RESTART
        defw    INSTR_33_EXIT_DESC
        defw    INSTR_34_RETURN
        defw    INSTR_35_GOTO
        defw    INSTR_36_PAUSE
        defw    INSTR_37_SET_FLAG
        defw    INSTR_38_SET_EVID
        defw    INSTR_39_CLS
        defw    INSTR_40_IF_EVID_OBJ
        defw    INSTR_41_PRINT_CHRS
        defw    INSTR_42_EXIT_MSG_OBJ
        defw    INSTR_43_IF_OBJ_INSIDE
        defw    INSTR_44_EXEC_CMD
        defw    INSTR_45_WAIT_KEY
        defw    INSTR_02_EXIT
        defw    INSTR_02_EXIT
        defw    INSTR_02_EXIT
        defw    INSTR_02_EXIT

;===============================================================
; VARIAVEIS EXTRAS
; Variaves adicionais que nao fazem parte da TABELA DE VARIAVEIS
;===============================================================
CURSOR_INPUT_BUFFER:
        defw    INPUT_BUFFER+1          ; ponteiro para posicao atual do cursor no INPUT BUFFER
END_RETORNO_PRIMEIRO_BYTE:
        defw    $b83b                   ; endereco inicial da rotina que executou a chamada EXEC FUNC($) mais recente
END_RETORNO_PROX_BYTE:
        defw    $b882                   ; endereco seguinte dentro da rotina que executou a chamada EXEC FUNC($) mais recente

;===============================================================
; TABELA DE CONSTANTES
; Reproduz conteudo dos enderecos $6570 a $6588 da versao MSX
;===============================================================
        org     $6570
END_TABELA_VERBOS:
        defw    $70d6                   ; endereco inicial da lista de verbos
END_TABELA_NOMES:
        defw    $72a6                   ; endereco inicial da lista de nomes de objetos
END_TABELA_LOCAIS:
        defw    $74eb                   ; endereco inicial da lista de locais
END_TABELA_COMANDOS:
        defw    $78ee                   ; endereco inicial da lista de comandos
END_TABELA_MENSAGENS:
        defw    $7e9a                   ; endereco inicial da lista de mensagens
END_TABELA_FUNCOES:
        defw    $b8be                   ; endereco inicial da lista de funcoes
END_TABELA_CONEXOES:
        defw    $c417                   ; endereco inicial da lista de conexoes N,S,L,O
END_TABELA_OBJETOS:
        defw    $c4e0                   ; endereco inicial da lista de objetos
END_FIM_TABELAS:
        defw    $c70a                   ; endereco final das listas
; nao usado
        defw    $73fd
; nao usado
        defw    $672f
COL40:
        defb    $0d                     ; coluna atual para impressao em modo texto 40x24 (valores validos: 0 a 39)
ROW40:
        defb    $03                     ; linha atual para impressao em modo texto 40x24 (valores validos: 0 a 23)
; nao usado
        defb    $00

;===============================================================
; TABELAS DE VARIAVEIS (AREA PRESERVADA POR SAVE/LOAD)
; Reproduz estrutura dos endereos $6589 a $666f da versao MSX
;===============================================================
TABELA_VARS:
        defb    $3f
CONTADOR_TEMPO:
        defw    $01cd                   ; contador de tempo usado para atualizacao do relogio (incrementado varias vezes por segundo)
COORD_RESPOSTA:
        defw    $0405                   ; coordenada inicial de impressao de respostas, equivale a "PRINT AT 4,5;"
VERBO_ATUAL:
        defb    $2d                     ; verbo digitado no comando atual do jogador
OBJ1_ATUAL:
        defb    $35                     ; primeiro objeto digitado no comando atual do jogador
OBJ2_ATUAL:
        defb    $00                     ; segundo objeto digitado no comando atual do jogador
OBJ1_ANTERIOR:
        defb    $06                     ; primeiro objeto digitado no comando anterior do jogador
OBJ_EVID:
        defb    $1a                     ; objeto "em evidencia"
MAX_OBJS_JOGADOR:
        defb    $07                     ; quantidade maxima de objetos que jogador pode carregar
MAX_OBJS_CONTAINER:
        defb    $04                     ; quantidade maxima de objetos que cabem na sacola
INTERROMPER_INTERPRETADOR:
        defb    $00                     ; deve interromper interpretador? (nesse caso desvia para endereco HL)
END_PRONOME_INPUT_BUFFER:
        defw    $03a3                   ; endereco do input buffer onde encontrou pronome (iniciando com prefixo '-')
END_PRIMEIRO_BYTE:
        defw    $b8bf                   ; endereco inicial da rotina atualmente em execucao
END_PROX_BYTE:
        defw    $b8de                   ; endereco atual de parsing no input buffer ou atual da rotina atualmente em execucao
PRINT_COORD:
        defw    $028a                   ; preserva coordenadas na tela do final da resposta anterior
VALOR_REF_LIST:
        defb    $32                     ; valor de comparacao para listagem de objetos (posicao atual se LIST_POS, $fa se LIST_PLAYER, $fb se LIST_CONTAINER)
CONTADOR_GENERICO:
        defb    $38                     ; contador auxiliar generico (durante parsing armazena numero do verbo ou objeto, durante instrucoes LIST conta
                                        ;   quantos objetos ja foram impressos, durante impressao decimal indica zeros a esquerda)

;
; TABELA DE FLAGS
;
TABELA_FLAGS:
FLAG_0_ESCURIDAO:
        defb    $00                     ; jogador na escuridao? (nesse caso desabilita impressao de mensagens)
FLAG_1_DIGITADO_PRONOME:
        defb    $00                     ; encontrou pronome (com prefixo '-') no input buffer?
FLAG_2_IMPRIMIR_PRONOME:
        defb    $00                     ; ainda tem pronome a ser impresso?
; nao usado
        defb    $00

STACK_PTR:
        defw    $64e8

; TABELA DE REGISTRADORES
; Registradores 1 a 14 sao usados pela "engine" e acessiveis pelos scripts do jogo
; Registradores 15 a 40 sao usados apenas pelos scripts do jogo
; Registradores 41 a 99 nao sao usados
REG01_POS_ATUAL:
        defb    $24                     ; armazena posicao atual do jogador
REG02_LSB_CONTADOR_COMANDOS:
        defb    $00                     ; armazena byte menos significativo do contador de comandos
REG03_MSB_CONTADOR_COMANDOS:
        defb    $00                     ; armazena byte mais significativo do contador de comandos
REG04_CONTADOR_COMANDOS_INCR:
        defb    $00                     ; contador crescente de comandos (se <> zero)
REG05_CONTADOR_COMANDOS_DECR:
        defb    $00                     ; contador decrescente de comandos (se <> zero), se chegar a zero executa FUNC(2)
REG06_CONTADOR_COMANDOS_ESCURO:
        defb    $00                     ; contador de comandos consecutivos no escuro, se chegar a 8 executa FUNC(3)
REG07_CONTADOR_OBJS_CONTAINER:
        defb    $00                     ; contador de objetos dentro da sacola
REG08_CONTADOR_OBJS_JOGADOR:
        defb    $05                     ; contador de objetos carregados pelo jogador
REG09_LOCAL_ESCURO:
        defb    $00                     ; jogador em local escuro?
REG10_LUZ_ACESA:
        defb    $00                     ; luz do lampiao acesa?
REG11_RELOGIO_MINUTOS:
        defb    $1e                     ; mostrador de minutos do relogio
REG12_RELOGIO_HORAS:
        defb    $08                     ; mostrador de horas do relogio
REG13_RELOGIO_DIAS:
        defb    $07                     ; mostrador de dias do relogio
REG14_FATOR_RELOGIO:
        defb    $06                     ; fator de ajuste da velocidade do relogio
REG15:
        defb    $11                     ; quantidade de dinheiro com o jogador
REG16:
        defb    $00                     ; contador de uso da sacola
REG17:
        defb    $00                     ; contador de crimes
REG18:
        defb    $00                     ; (nao usado)
REG19:
        defb    $00                     ; quantidade de ouro
REG20:
        defb    $00                     ; carteira vazia?
REG21:
        defb    $00                     ; controle de escuridao
REG22:
        defb    $00                     ; quantidade de querosene no lampiao
REG23:
        defb    $00                     ; explosao no aeroporto?
REG24:
        defb    $00                     ; delegado no local?
REG25:
        defb    $00                     ; contador auxiliar
REG26:
        defb    $1e                     ; quantidade de palitos de fosforo
REG27:
        defb    $00                     ; situacao do Delegado
REG28:
        defb    $05                     ; quantidade de dinheiro na conta bancaria (2 digitos menos significativos)
REG29:
        defb    $00                     ; quantidade de dinheiro na conta bancaria (2 digitos intermediarios)
REG30:
        defb    $00                     ; quantidade de dinheiro na conta bancaria (2 digitos mais significativos)
REG31:
        defb    $00                     ; contador de controle da conversa de gerente com medico no bar
REG32:
        defb    $00                     ; situacao do Boca de Traira
REG33:
        defb    $00                     ; explosao no fundo do Barranco Felicidade?
REG34:
        defb    $00                     ; explosao no Posto Telefonico?
REG35:
        defb    $00                     ; explosao na Caixa Economica?
REG36:
        defb    $00                     ; (nao usado)
REG37:
        defb    $00                     ; (nao usado)
REG38:
        defb    $00                     ; (nao usado)
REG39:
        defb    $00                     ; (nao usado)
REG40:
        defb    $00                     ; contador de fuga da cadeia

; demais registradores (nao usados)
        defb    $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
        defb    $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
        defb    $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
        defb    $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
        defb    $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
        defb    $00, $00, $00, $00, $00, $00, $00, $00, $00

; LOCALIZACAO ATUAL DE CADA OBJETO NO JOGO
; $fa = jogador possui objeto
; $fb = objeto dentro da mala aberta
; $fd = objeto dentro da mala fechada
TABELA_POS_OBJS:
        defb    $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
        defb    $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
        defb    $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
        defb    $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
        defb    $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
        defb    $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
        defb    $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
        defb    $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
        defb    $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
        defb    $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
        defb    $ff
        defb    $3f
FIM_TABELAS:
        defb    $3f

;===============================================================
; INICIO DO JOGO (RAND USR 26224)
;===============================================================
; mostra imagem 'PRESSIONE ENTER'
        ld      hl,IMG_ENTER
        ld      a,$57
        ld      d,$50
MOSTRA_IMG_ENTER:
        ld      e,$e8
        ld      bc,$10
        ldir
        inc     d
        cp      d
        jr      nz,MOSTRA_IMG_ENTER

; preserva tela de abertura
        ld      hl,$4000
        ld      de,COPY_SCREEN
        ld      bc,$1b00
        ldir

; mostra tela de abertura
MOSTRA_TELA_ABERTURA:
        ld      hl,COPY_SCREEN
        ld      de,$4000
        ld      bc,$1b00
        ldir

; aguarda tecla 'ENTER'
ESPERA_TECLA_ENTER:
        call    ESPERA_TECLA
        cp      $0d                     ; newline
        jr      nz,ESPERA_TECLA_ENTER

; inicializa variavel de controle
        xor     a
        ld      (FLAG_0_ESCURIDAO),a

; zera tabelas de registradores e de posicoes
        ld      hl,REG01_POS_ATUAL
        ld      b,199
APAGA_VARS:
        ld      (hl),a
        inc     hl
        djnz    APAGA_VARS

; seta posicao inicial dos objetos
        ld      hl,(END_TABELA_OBJETOS)
        ld      de,TABELA_POS_OBJS
INICIA_POS_OBJ:
        inc     hl
        inc     de
        ld      a,(hl)
        ld      (de),a
        cp      $ff
        jr      z,INICIA_JOGO
        ld      a,$fc
INICIA_POS_OBJ_LOOP:
        inc     hl
        cp      (hl)
        jr      nz,INICIA_POS_OBJ_LOOP
        jr      INICIA_POS_OBJ

; monta tela de jogo
INICIA_JOGO:
        call    DESENHA_TELA_TEXTO

; executa FUNC(1) para inicializacao do jogo, deixando interpretador de instrucoes prosseguir com loop normal de execucao
        ld      a,1                     ; FUNC(1)
        jr      JUMP_EXECUTA_FUNCAO

;===============================================================
; VERIFICA E PROCESSA COMANDOS NO ESCURO
;===============================================================
CHECA_ESCURIDAO:
        xor     a
        ld      (FLAG_0_ESCURIDAO),a
        ld      a,(REG09_LOCAL_ESCURO)
        or      a
        ret     z                       ; retorna se local nao escuro
        ld      a,(REG10_LUZ_ACESA)
        or      a                       ; luz do lampiao acesa?
        jr      z,PROCESSA_ESCURIDAO
        ld      hl,TABELA_POS_OBJS+2    ; OBJ(2) = 'LAMPIAO'
        ld      a,(hl)
        cp      $fa                     ; jogador possui lampiao?
        ret     z
        ld      a,(REG01_POS_ATUAL)
        cp      (hl)                    ; ou lampiao na posicao atual?
        ret     z
PROCESSA_ESCURIDAO:
        ld      a,$01
        ld      (FLAG_0_ESCURIDAO),a    ; indica escuridao
        ld      hl,REG06_CONTADOR_COMANDOS_ESCURO
        inc     (hl)                    ; incrementa contador de comandos no escuro
        ld      a,(hl)
        cp      8
        ret     c                       ; oitavo comando no escuro?
        pop     de                      ; descarta endereco de retorno
        ld      a,3                     ; FUNC(3)
JUMP_EXECUTA_FUNCAO:
        jr      EXECUTA_FUNCAO

;===============================================================
; AGUARDA E PROCESSA PROXIMO COMANDO DO JOGADOR
;===============================================================
PROX_COMANDO_CHECA_FUNC5:
; reseta stack pointer
        ld      sp,(STACK_PTR)

; executa funcao 5 se existir
        ld      a,5                     ; FUNC(5)
        ld      hl,(END_TABELA_FUNCOES)
        call    BUSCA_N_ESIMO
        xor     a
        cp      (hl)
        jr      nz,JUMP_INTERPRETA_INSTR

PROX_COMANDO_APOS_FUNC5:
        ld      a,(FLAG_0_ESCURIDAO)
        or      a
        jr      z,ESPERA_PROX_COMANDO
        ld      hl,(END_TABELA_MENSAGENS)
        ld      a,12                    ; MSG(12)  = CLS; "A noite esta muito escura. Eu nao consigo enxergar quase nada."
        call    BUSCA_N_ESIMO
        call    PRINT_STRING

ESPERA_PROX_COMANDO:
; preserva coordenadas na tela
        ld      hl,(COL40)
        ld      (PRINT_COORD),hl
; recebe novo comando
        call    INPUT_COMANDO
; apaga comando anterior do topo da tela
        ld      hl,$0003                ; PRINT AT 0,3;
        call    APAGA_TRECHO
        call    PRINT40                 ; apaga espaco adicional caso comando anterior tenha estourado tamanho limite
; recupera coordenadas na tela, caso FUNC(2) ou FUNC(3) resolvam imprimir mais alguma coisa na area de respostas
        ld      hl,(PRINT_COORD)
        ld      (COL40),hl
; verifica escuridao e atualiza contadores
        call    CHECA_ESCURIDAO
        ld      hl,(REG02_LSB_CONTADOR_COMANDOS)
        inc     hl
        ld      (REG02_LSB_CONTADOR_COMANDOS),hl
        ld      a,(REG04_CONTADOR_COMANDOS_INCR)
        or      a
        jr      z,ATUALIZA_REG05
        inc     a
        ld      (REG04_CONTADOR_COMANDOS_INCR),a
ATUALIZA_REG05:
        ld      a,(REG05_CONTADOR_COMANDOS_DECR)
        or      a
        jr      z,INICIO_PARSER
        dec     a
        ld      (REG05_CONTADOR_COMANDOS_DECR),a
        or      a
        jr      nz,INICIO_PARSER
        ld      a,2                     ; FUNC(2)
EXECUTA_FUNCAO:
        ld      hl,(END_TABELA_FUNCOES)
        call    BUSCA_N_ESIMO
JUMP_INTERPRETA_INSTR:
        jp      INTERPRETA_INSTR
INICIO_PARSER:
        ld      hl,$0003                ; PRINT AT 0,3;
        call    PRINTAT40
        ld      h,INPUT_BUFFER/256
        ld      a,(hl)
        cp      $19                     ; cursor
        jr      nz,COMANDO_NAO_VAZIO
        ld      a,$17                   ; marcador de final de comando
        call    PRINT40
        call    APAGA_INPUT
COMANDO_DESC:
        call    APAGA_RESPOSTA
        call    CHECA_ESCURIDAO
        ld      a,(REG01_POS_ATUAL)
        ld      hl,(END_TABELA_LOCAIS)
PRINT_N_ESIMO_E_PROX_COMANDO:
        call    BUSCA_N_ESIMO
        call    PRINT_STRING_SE_VISIVEL
        jp      PROX_COMANDO_CHECA_FUNC5
COMANDO_NAO_VAZIO:
        ld      (END_PROX_BYTE),hl
        xor     a
        ld      (FLAG_1_DIGITADO_PRONOME),a
        ld      (FLAG_2_IMPRIMIR_PRONOME),a
        ld      hl,(END_TABELA_VERBOS)
        inc     hl
BUSCA_PROX_VERBO:
        inc     a
        ld      (CONTADOR_GENERICO),a
        ld      a,(hl)
        cp      $ff
        jr      nz,COMPARA_PROX_VERBO
        ld      a,$17                   ; marcador de final de comando
        call    PRINT40
        call    APAGA_INPUT
        call    APAGA_RESPOSTA
COMANDO_NAO_ENTENDIDO:
        ld      a,13                    ; MSG(13) = "Perdao, nao entendi."
RECUSA_COMANDO:
        ld      hl,(END_TABELA_MENSAGENS)
        jr      PRINT_N_ESIMO_E_PROX_COMANDO
COMPARA_PROX_VERBO:
        ld      de,(END_PROX_BYTE)
        call    COMPARA_PROX_PALAVRA
        jr      z,VERBO_IDENTIFICADO
        ld      a,(CONTADOR_GENERICO)
        jr      BUSCA_PROX_VERBO
VERBO_IDENTIFICADO:
        ld      (END_PROX_BYTE),de
        call    PRINT_PALAVRA
        ld      hl,VERBO_ATUAL
        ld      a,(CONTADOR_GENERICO)
        ld      (hl),a
        inc     hl
        ld      (hl),0
        inc     hl
        ld      (hl),0
        cp      5
        jr      nc,COMANDO_NAO_MOVIMENTO

; processa comandos de movimento N,S,L,O
        push    af
        ld      a,$17                   ; marcador de final de comando
        call    PRINT40
        call    APAGA_INPUT
        call    APAGA_RESPOSTA
        ld      a,(REG01_POS_ATUAL)
        dec     a
        ld      h,0
        ld      l,a
        add     hl,hl
        add     hl,hl
        ex      de,hl
        ld      hl,(END_TABELA_CONEXOES)
        inc     hl
        add     hl,de
        pop     af
        dec     a
        ld      b,0
        ld      c,a
        add     hl,bc
        ld      a,(hl)
        or      a
        jr      nz,DIRECAO_VALIDA
        ld      a,14                    ; MSG(14) = "E impossivel ir nesta direcao."
        jr      RECUSA_COMANDO
DIRECAO_VALIDA:
        cp      100
        jr      nc,DIRECAO_FUNCAO
        ld      (REG01_POS_ATUAL),a
        jp      COMANDO_DESC
DIRECAO_FUNCAO:
        sub     100
        ld      hl,(END_TABELA_FUNCOES)
        call    BUSCA_N_ESIMO
        jp      INTERPRETA_INSTR
COMANDO_NAO_MOVIMENTO:
        call    BUSCA_PROX_OBJ
        jr      z,TERMINO_PARSER
        ld      (OBJ1_ATUAL),a
        call    BUSCA_PROX_OBJ
        jr      z,TERMINO_PARSER
        ld      (OBJ2_ATUAL),a
TERMINO_PARSER:
        ld      a,$17                   ; marcador de final de comando
        call    PRINT40
        call    APAGA_INPUT
        call    APAGA_RESPOSTA
        ld      a,(VERBO_ATUAL)
        cp      5
        jp      z,SAVE_TAPE
        cp      6
        jp      z,LOAD_TAPE
        cp      20                      ; ignora pronome nos 19 primeiros verbos
        jr      c,COMANDO_SEM_PRONOME
        ld      a,(FLAG_1_DIGITADO_PRONOME)
        or      a
        jr      z,COMANDO_SEM_PRONOME
        ld      a,(OBJ1_ATUAL)
        ld      (OBJ2_ATUAL),a
        ld      a,(OBJ1_ANTERIOR)
        ld      (OBJ1_ATUAL),a
COMANDO_SEM_PRONOME:
        ld      a,(OBJ1_ATUAL)
        ld      (OBJ1_ANTERIOR),a
        ld      hl,VERBO_ATUAL
        ld      c,(hl)
        inc     hl
        ld      b,(hl)
        ld      hl,(END_TABELA_COMANDOS)
        inc     hl
COMPARA_VERBO_OBJ1:
        ld      e,(hl)
        inc     hl
        ld      d,(hl)
        inc     hl
        ex      de,hl
        and     a
        sbc     hl,bc
        ex      de,hl
        jr      z,ENCONTROU_VERBO_OBJ1
PROX_VERBO_OBJ1:
        ld      a,$fc
        push    bc
        ld      bc,1000
        cpir
        pop     bc
        ld      a,$ff
        cp      (hl)
        jr      nz,COMPARA_VERBO_OBJ1

; comando nao encontrado na Tabela de Comandos
        ld      a,c
        cp      20
        jr      c,COMANDO_INVALIDO
        cp      35
        jr      nc,COMANDO_INVALIDO

; tratamento especial para verbos entre 20 e 34 quando nao existe um comando definido
        sub     14
        push    af
        sub     5
        push    af
        ld      a,b
        or      a
        jr      z,COMANDO_INVALIDO      ; objeto e' obrigatorio em verbos entre 20 e 34
        ld      hl,(END_TABELA_OBJETOS)
        call    BUSCA_N_ESIMO
        inc     hl
        ld      e,(hl)                  ; carrega bits de consistencia do objeto
        pop     af
        cp      8                       ; apenas verbos entre 20 e 26 possuem bit de consistencia
        jr      nc,VERBO_SEM_BIT_CONSISTENCIA
        ld      b,a
CHECA_BIT_CONSISTENCIA:
        rrc     e
        djnz    CHECA_BIT_CONSISTENCIA
        jr      nc,COMANDO_INVALIDO
VERBO_SEM_BIT_CONSISTENCIA:
        pop     af
        jp      EXECUTA_FUNCAO          ; executa FUNC(6..20) correspondente a VERB(20..34)
COMANDO_INVALIDO:
        ld      a,(OBJ1_ATUAL)
        or      a
        jp      z,COMANDO_NAO_ENTENDIDO
        ld      a,15                    ; MSG(15) = "Isto nao e possvel."
        jp      RECUSA_COMANDO
ENCONTROU_VERBO_OBJ1:
        ld      e,(hl)
        inc     hl
        ld      a,(OBJ2_ATUAL)
        cp      e
        jr      nz,PROX_VERBO_OBJ1

INTERPRETA_INSTR:
        ld      (END_PRIMEIRO_BYTE),hl
INTERPRETA_PROX_INSTR:
        ld      a,(hl)
        inc     hl
        cp      $d2
        jr      nc,INTERPRETA_PROX_INSTR
        ld      c,(hl)
        inc     hl
        ld      (END_PROX_BYTE),hl
        ld      hl,RETORNO_INTERPRETADOR
        push    hl
        ld      h,TABELA_INSTRUCOES/256
        add     a,a
        ld      l,a
        ld      e,(hl)
        inc     hl
        ld      d,(hl)
        push    de
        xor     a
        ld      (INTERROMPER_INTERPRETADOR),a
        ld      d,a
        ld      e,a
        ld      h,a
        ld      l,a
        ld      b,a
        ld      a,c
        ret
RETORNO_INTERPRETADOR:
        ld      a,(INTERROMPER_INTERPRETADOR)
        or      a
        jr      z,CONTINUA_INTERPRETADOR
        jp      (hl)
CONTINUA_INTERPRETADOR:
        ld      hl,(END_PROX_BYTE)
        jr      INTERPRETA_PROX_INSTR

;===============================================================
; RECEBE UM NOVO COMANDO DO JOGADOR
;===============================================================
; limpa input buffer
INPUT_COMANDO:
        ld      hl,INPUT_BUFFER
        ld      (hl),$18                ; marcador de inicio de comando
        ld      b,35
        inc     hl
        push    hl
LIMPA_INPUT:
        ld      (hl),$20                ; espaco em branco
        inc     hl
        djnz    LIMPA_INPUT
        ld      (hl),$fc

; atualiza cursor
        pop     hl                      ; ponteiro para inicio do INPUT BUFFER
INICIA_CURSOR_INPUT:
        ld      (hl),$19                ; atualiza cursor no INPUT BUFFER
        ld      (CURSOR_INPUT_BUFFER),hl

; imprime input buffer
        dec     hl
        ld      d,h
        ld      e,l
        ld      h,23                    ; row 23
        call    PRINT_AT_STRING

; zera ultima tecla pressionada
ESPERA_TECLA_INPUT:
        xor     a
        ld      ($5c08),a

LOOP_INPUT:
        call    ATUALIZA_RELOGIO
; executa FUNC(4) se existir
        ld      a,4                     ; FUNC(4)
        ld      hl,(END_TABELA_FUNCOES)
        call    BUSCA_N_ESIMO
        xor     a
        cp      (hl)
        call    nz,INTERPRETA_INSTR
; leitura teclado
        ld      a,($5c08)               ; LASTK (ultima tecla pressionada)
        or      a
        jr      z,LOOP_INPUT            ; repete enquanto nenhuma tecla pressionada

        ld      hl,(CURSOR_INPUT_BUFFER)
        cp      $0c
        jr      z,TECLA_DEL
        cp      $0d                     ; newline
        ret     z
        cp      $20
        jr      c,ESPERA_TECLA_INPUT
        cp      $61
        jr      c,TECLA_MAIUSCULA
        sub     $20
TECLA_MAIUSCULA:
        cp      $61
        jr      nc,ESPERA_TECLA_INPUT
; troca numeros por caracteres acentuados
        call    CONVERTE_ACENTOS

        ld      (hl),a                  ; insere tecla no INPUT BUFFER
        inc     hl                      ; avanca cursor
        ld      a,(hl)
        cp      $fc                     ; chegou no final do INPUT BUFFER?
        jr      nz,INICIA_CURSOR_INPUT
        dec     hl
        jr      INICIA_CURSOR_INPUT     ; repete
TECLA_DEL:
        ld      (hl),$20                ; apaga com espaco em branco
        dec     hl
        ld      a,(hl)
        cp      $18                     ; marcador de inicio de comando
        jr      nz,INICIA_CURSOR_INPUT  ; atualiza cursor no INPUT BUFFER
        jr      INPUT_COMANDO           ; se inicio da string entao reseta INPUT BUFFER

;===============================================================
; COMPARA PROXIMA PALAVRA NO INPUT BUFFER (ENDERECO DE) COM
;   ITENS DE UMA ENTRADA NA TABELA DE PALAVRAS (ENDERECO HL)
;===============================================================
COMPARA_PROX_PALAVRA:
        ld      a,(de)
        cp      $20                     ; espaco em branco
        jr      nz,INICIO_PROX_PALAVRA
        inc     de
        jr      COMPARA_PROX_PALAVRA
INICIO_PROX_PALAVRA:
        ld      (END_PROX_BYTE),de
COMPARA_PRIMEIRA_LETRA:
        ld      a,(de)
        cp      (hl)
        jr      z,PRIMEIRA_LETRA_BATEU
BUSCA_PROX_ITEM:
        ld      a,(hl)
        inc     hl
        cp      $fc
        jr      nz,CHECA_PROX_ITEM
        and     a
        ret
CHECA_PROX_ITEM:
        cp      ':'
        jr      nz,BUSCA_PROX_ITEM
        jr      COMPARA_PRIMEIRA_LETRA
PRIMEIRA_LETRA_BATEU:
        push    hl
        push    de
PROX_LETRA_BATEU:
        inc     hl
        inc     de
        ld      a,(de)
        cp      $20                     ; espaco em branco
        jr      z,PALAVRA_BATEU
        cp      $19                     ; cursor
        jr      z,PALAVRA_BATEU
        cp      '-'
        jr      z,INICIO_PRONOME
        cp      (hl)
        jr      z,PROX_LETRA_BATEU
        pop     de
        pop     hl
        jr      BUSCA_PROX_ITEM
PALAVRA_BATEU:
        pop     hl
        pop     hl
        ret
INICIO_PRONOME:
        ld      (END_PRONOME_INPUT_BUFFER),de
        ld      (FLAG_1_DIGITADO_PRONOME),a
        ld      (FLAG_2_IMPRIMIR_PRONOME),a
PROX_LETRA_PRONOME:
        ld     a,(de)
        cp      $20                     ; espaco em branco
        jr      z,PALAVRA_BATEU
        cp      $19                     ; cursor
        jr      z,PALAVRA_BATEU
        inc     de
        jr      PROX_LETRA_PRONOME

;===============================================================
; IDENTIFICA PROXIMO OBJETO NO INPUT BUFFER
;===============================================================
BUSCA_PROX_OBJ:
        ld      hl,(END_PROX_BYTE)
        ld      a,(hl)
        cp      $19                     ; cursor
        ret     z
        ex      de,hl
        xor     a
        ld      (CONTADOR_GENERICO),a

; se prox palavra e' preposicao, apenas copia para topo da tela e continua busca
        ld      hl,TABELA_PREPOSICOES
        call    COMPARA_PROX_PALAVRA
        jr      nz,IDENTIFICA_OBJ
        ld      (END_PROX_BYTE),de
        ld      a,$20                   ; espaco em branco
        call    PRINT40
        call    PRINT_PALAVRA
        jr      BUSCA_PROX_OBJ

IDENTIFICA_OBJ:
        ld      de,(END_PROX_BYTE)
        ld      hl,(END_TABELA_OBJETOS)
        inc     hl
COMPARA_PROX_OBJ:
        ld      a,(CONTADOR_GENERICO)
        inc     a
        ld      (CONTADOR_GENERICO),a
        inc     hl
        inc     hl
        call    COMPARA_PROX_PALAVRA
        jr      z,OBJ_IDENTIFICADO
        ld      a,(hl)
        cp      $ff
        jr      nz,COMPARA_PROX_OBJ
        ld      hl,(END_PROX_BYTE)
BUSCA_PROX_ENTRADA_OBJ:
        ld     a,(hl)
        inc     hl
        cp      $19                     ; cursor
        ret     z
        cp      $20                     ; espaco em branco
        jr      nz,BUSCA_PROX_ENTRADA_OBJ
        ld      (END_PROX_BYTE),hl
        jr      BUSCA_PROX_OBJ
OBJ_IDENTIFICADO:
        ld      (END_PROX_BYTE),de
        ld      a,$20                   ; espaco em branco
        call    PRINT40
        call    PRINT_PALAVRA
        ld      a,(CONTADOR_GENERICO)
        and     a
        ret

;===============================================================
; APAGA AREA DE DIGITACAO DE COMANDOS NA PARTE INFERIOR DA TELA
;===============================================================
APAGA_INPUT:
        ld      hl,$1703                ; PRINT AT 23,3;
APAGA_TRECHO:
        ld      a,$20                   ; espaco em branco
PREENCHE_TRECHO:
        call    PRINTAT40
        ld      b,36                    ; preenche com 36 caracteres
TRECHO_LOOP:
        call    PRINT40
        djnz    TRECHO_LOOP
        ret

;===============================================================
; IMPRIME NO TOPO DA TELA UMA PALAVRA DIGITADA PELO JOGADOR
;===============================================================
PRINT_PALAVRA:
        ld      a,(COL40)
        cp      231
        ret     nc
        ld      a,(hl)
        inc     hl
        cp      ':'
        jr      z,PRINT_PRONOME
        cp      $fc
        jr      z,PRINT_PRONOME
        call    PRINT40
        jr      PRINT_PALAVRA
PRINT_PRONOME:
        ld      a,(FLAG_2_IMPRIMIR_PRONOME)
        or      a
        ret     z
        xor     a
        ld      (FLAG_2_IMPRIMIR_PRONOME),a
        ld      hl,(END_PRONOME_INPUT_BUFFER)
PRINT_LOOP_PRONOME:
        ld      a,(COL40)
        cp      231
        ret     nc
        ld      a,(hl)
        inc     hl
        cp      $19                     ; cursor
        ret     z
        cp      $20                     ; espaco em branco
        ret     z
        call    PRINT40
        jr      PRINT_LOOP_PRONOME

;===============================================================
; TRANSFORMA NUMERO DIGITADO EM UM CARACTER ACENTUADO.
; Essa rotina implementa um algoritmo generico que busca o valor
; de A na Tabela de Acentos e, se encontrar, substitui pelo byte
; seguinte na tabela.
;===============================================================
CONVERTE_ACENTOS:
        ld      de,TABELA_ACENTOS
        ld      c,a
        inc     a
CONVERTE_ACENTOS_LOOP:
        cp      c
        ld      a,(de)
        ret     z
        inc     de
        or      a
        jr      nz,CONVERTE_ACENTOS_LOOP
        ld      a,c
        ret

;===============================================================
; ROTINA DE ATUALIZACAO DO RELOGIO
; Cada minuto no jogo equivale a 5 segundos na vida real
;===============================================================
ATUALIZA_RELOGIO:
        ld      hl,(CONTADOR_TEMPO)
        inc     hl
        ld      (CONTADOR_TEMPO),hl
        ld      a,(REG14_FATOR_RELOGIO)
        cp      h
        ret     nz
        xor     a
        ld      (CONTADOR_TEMPO+1),a
        ld      hl,REG11_RELOGIO_MINUTOS
        ld      a,60
        call    INC_MOSTRADOR_RELOGIO
        inc     hl
        ld      a,24
        call    INC_MOSTRADOR_RELOGIO
        inc     hl
        ld      a,31
        call    INC_MOSTRADOR_RELOGIO
        inc     (hl)
        ret
INC_MOSTRADOR_RELOGIO:
        inc     (hl)
        cp      (hl)
        jr      z,ZERA_MOSTRADOR_RELOGIO
        pop     hl
        ret
ZERA_MOSTRADOR_RELOGIO:
        ld      (hl),0
        ret

;===============================================================
; CARREGA JOGO DA FITA
;===============================================================
LOAD_TAPE:
; imprime mensagem e prepara para iniciar acesso a fita
        ld      hl,MSG_CARREGANDO
        call    PREPARA_TAPE

; carrega primeiro em area temporaria para nao corromper tabela se ocorrer erro de leitura
        ld      ix,LOAD_BUFFER

; reproduz inicio da rotina LD-BYTES em $0556, para trocar endereco de retorno LD-RET por TAPE_RET
        inc     d
        ex      af,af'
        dec     d
        di
        ld      a,$0f
        out     ($fe),a

; executa rotina LD-BYTES pulando a parte inicial, com retorno em TAPE_RET em vez de LD-RET
        call    $0561

; verifica erro
        jr      nc,TAPE_ERRO

; copia dados carregados para tabela de variaveis
        ld      hl,LOAD_BUFFER
        ld      de,TABELA_VARS
        ld      bc,FIM_TABELAS-TABELA_VARS
        ldir

; imprime "Ok."
TAPE_OK:
        call    INSTR_27_EXIT_OK

; retorna para o jogo
TAPE_END:
        jp      (hl)

;===============================================================
; GRAVA JOGO EM FITA
;===============================================================
SAVE_TAPE:
; imprime mensagem e prepara para iniciar acesso a fita
        ld      hl,MSG_GRAVANDO
        call    PREPARA_TAPE

; executa rotina SA-BYTES em $04c2 porem pulando a parte inicial, com retorno em TAPE_RET em vez de LD-RET
        call    $04C5

; verifica erro
        jr      c,TAPE_OK

; imprime mensagem de erro e retorna para o jogo
TAPE_ERRO:
        ld      hl,MSG_ERRO
        call    PRINT_STRING_AND_EXIT
        jr      TAPE_END

;===============================================================
; PREPARACAO DO ACESSO A FITA
;===============================================================
PREPARA_TAPE:
        call    PRINT_STRING
        ld      ix,TABELA_VARS
        ld      de,FIM_TABELAS-TABELA_VARS
        ld      a,$ff
        scf
        ld      hl,TAPE_RET
        ret

;===============================================================
; TERMINO DO ACESSO A FITA
; Reproduz rotina LD-RET em $053f na ROM, porem sem a parte de
; interrupcao por BREAK
;===============================================================
TAPE_RET:
        push    af
        ld      a,($5c48)
        and     $38
        rrca
        rrca
        rrca
        out     ($fe),a
        ei
        pop     af
        ret

;===============================================================
; LOCALIZA ENDERECO DA A-ESIMA ENTRADA NA TABELA APONTADA POR HL
;===============================================================
BUSCA_N_ESIMO:
        ld      e,a
        inc     hl
        ld      a,$fc
        ld      bc,$8000
LOOP_BUSCA_N_ESIMO:
        dec     e
        ret     z
        cpir
        jr      LOOP_BUSCA_N_ESIMO

;===============================================================
; LOCALIZA E CARREGA POSICAO DO BC-ESIMO OBJETO
;===============================================================
CARREGA_POS_OBJ:
        ld      hl,TABELA_POS_OBJS
        add     hl,bc
        ld      a,(hl)
        ret

;===============================================================
; LOCALIZA POSICAO DO BC-ESIMO REGISTRADOR
;===============================================================
LOCALIZA_REG:
        ld      hl,TABELA_REGISTRADORES
        add     hl,bc
        ret

;===============================================================
; COMPARA BC-ESIMO REGISTRADOR COM VALOR DO BYTE SEGUINTE
;===============================================================
COMPARA_REG_COM_PROX_BYTE:
        call    LOCALIZA_REG
        ld      c,(hl)
        call    CARREGA_PROX_BYTE_INSTR
        cp      c
        ret

;===============================================================
; SUBSTITUI OBJETO ZERO POR OBJETO EM EVIDENCIA
;===============================================================
TROCA_OBJ_ZERO_POR_EVID:
        or      a
        ret     nz
        ld      a,(OBJ_EVID)
        ld      c,a
        ret

;===============================================================
; INSTRUCAO "NOP"
;===============================================================
INSTR_00_NOP:
        ld      hl,(END_PROX_BYTE)
        dec     hl
        jp      UPDATE_PROX_BYTE_INSTR

;===============================================================
; INSTRUCAO "PRINT MSG($)"
;===============================================================
INSTR_01_PRINT_MSG:
        ld      hl,(END_TABELA_MENSAGENS)
PRINT_N_ESIMO:
        call    BUSCA_N_ESIMO

PRINT_STRING_SE_VISIVEL:
        ld      a,(FLAG_0_ESCURIDAO)
        or      a
        ret     nz

PRINT_STRING:
        ld      a,(hl)
        inc     hl
        cp      $fc
        ret     z

PRINT_ABREV:
        cp      $0a
        jr      nc,PRINT_NEWLINE
        push    hl
        ld      hl,(END_TABELA_MENSAGENS)
        call    BUSCA_N_ESIMO
        call    PRINT_STRING
POP_HL_AND_PRINT_STRING:
        pop     hl
        jr      PRINT_STRING

PRINT_NEWLINE:
        jr      nz,PRINT_CLEAR
        ld      a,$0d                   ; newline
        call    PRINT40
        jr      PRINT_STRING

; apaga area de resposta (codigo 0b)
PRINT_CLEAR:
        cp      $0b
        jr      nz,PRINT_AT
        push    hl
        call    APAGA_RESPOSTA
        jr      POP_HL_AND_PRINT_STRING

; imprime AT (codigo 0c)
PRINT_AT:
        cp      $0c
        jr      nz,PRINT_CHAR
        ld      e,(hl)
        inc     hl
        ld      d,(hl)
        inc     hl
        ex      de,hl
; divide HL por 40, coloca resultado em H (linha) e resto em L (coluna)
        ld      bc,40
        xor     a
PRINT_AT_LOOP:
        inc     a
        sbc     hl,bc
        jr      nc,PRINT_AT_LOOP
        add     hl,bc
        dec     a
        ld      h,a
PRINT_AT_STRING:
        call    PRINTAT40
        ex      de,hl
        jr      PRINT_STRING

PRINT_CHAR:
        ld      b,1
        cp      $c0
        jr      c,PRINT_CHARS
        sub     $c0
        ld      b,a
PRINT_SPACES:
        ld      a,$20                   ; espaco em branco
PRINT_CHARS:
        call    PRINT40
        djnz    PRINT_SPACES
        jr      PRINT_STRING

;===============================================================
; INSTRUCAO "EXIT"
;===============================================================
INSTR_02_EXIT:
        ld      hl,PROX_COMANDO_CHECA_FUNC5
        jp      INTERROMPE_INSTR

;===============================================================
; INSTRUCAO "EXIT LIST_POS" 
;===============================================================
INSTR_03_EXIT_LIST_POS:
        ld      hl,MSG_NESTE_LOCAL_TEM
        call    PRINT_STRING_SE_VISIVEL
        ld      a,(REG01_POS_ATUAL)
LIST_OBJS_EM_A:
        ld      (VALOR_REF_LIST),a
        xor     a
        ld      (CONTADOR_GENERICO),a
        ld      hl,$070e                ; PRINT AT 7,14;
        call    PRINTAT40
        ld      c,a
        ld      hl,TABELA_POS_OBJS
LOOP_LIST_OBJS:
        inc     hl
        inc     c
        ld      a,$ff
        cp      (hl)
        jr      nz,LIST_PROX_OBJ
        ld      a,(CONTADOR_GENERICO)
        or      a
        jr      nz,INSTR_02_EXIT
        ld      hl,MSG_NADA_INTERESSANTE
PRINT_STRING_AND_EXIT:
        call    PRINT_STRING_SE_VISIVEL
        jr      INSTR_02_EXIT
LIST_PROX_OBJ:
        ld      a,(VALOR_REF_LIST)
        cp      (hl)
        jr      nz,LOOP_LIST_OBJS
        ld      a,(CONTADOR_GENERICO)
        cp      12
        jr      z,INSTR_02_EXIT
        inc     a
        ld      (CONTADOR_GENERICO),a
        push    hl
        push    bc
        ld      a,c
        call    INSTR_06_PRINT_OBJ
        ld      a,$06
        call    PRINT40
        pop     bc
        pop     hl
        jr      LOOP_LIST_OBJS

;===============================================================
; INSTRUCAO "EXIT LIST_PLAYER" 
;===============================================================
INSTR_04_EXIT_LIST_PLAYER:
        ld      hl,MSG_NOS_TEMOS
        call    PRINT_STRING_SE_VISIVEL
        ld      a,$fa
        jr      LIST_OBJS_EM_A

;===============================================================
; INSTRUCAO "EXIT LIST_CONTAINER" 
;===============================================================
INSTR_05_EXIT_LIST_CONTAINER:
        ld      a,$fb
        jr      LIST_OBJS_EM_A

;===============================================================
; INSTRUCAO "PRINT OBJ($)" 
;===============================================================
INSTR_06_PRINT_OBJ:
        call    TROCA_OBJ_ZERO_POR_EVID
        ld      hl,(END_TABELA_NOMES)
        jp      PRINT_N_ESIMO

;===============================================================
; INSTRUCAO "REG($)++" 
;===============================================================
INSTR_07_INC_REG:
        call    LOCALIZA_REG
        inc     (hl)
        ret

;===============================================================
; INSTRUCAO "REG($)--" 
;===============================================================
INSTR_08_DEC_REG:
        call    LOCALIZA_REG
        dec     (hl)
        ret

;===============================================================
; INSTRUCAO "REG($):=$" 
;===============================================================
INSTR_09_SET_REG:
        call    LOCALIZA_REG
        ld      c,0
SOMA_COM_PROX_BYTE:
        call    CARREGA_PROX_BYTE_INSTR
        add     a,c
        ld      (de),a
        ret

;===============================================================
; INSTRUCAO "REG($)+=$" 
;===============================================================
INSTR_10_ADD_REG:
        call    LOCALIZA_REG
        ld      c,(hl)
        jr      SOMA_COM_PROX_BYTE

;===============================================================
; INSTRUCAO "REG($)+=RND($)" 
;===============================================================
INSTR_11_ADD_REG_RND:
        call    LOCALIZA_REG
        call    CARREGA_PROX_BYTE_INSTR
        ld      c,a
        inc     c
        ld      a,(CONTADOR_TEMPO)
LOOP_INSTR_11:
        sub     c
        cp      c
        jr      nc,LOOP_INSTR_11
        ex      de,hl
        add     a,(hl)
        ld      (hl),a
        ret

;===============================================================
; INSTRUCAO "IF REG($)=$ GOTO @" 
;===============================================================
INSTR_12_IF_REG_EQUAL:
        call    COMPARA_REG_COM_PROX_BYTE
        jr      IF_Z_GOTO

;===============================================================
; INSTRUCAO "IF REG($)>$ GOTO @"
;===============================================================
INSTR_13_IF_REG_GREATER:
        call    COMPARA_REG_COM_PROX_BYTE
        jr      nc,CARREGA_PROX_BYTE_INSTR

GOTO_PROX_BYTE_INSTR:
        ld      hl,(END_PROX_BYTE)
        ld      a,(hl)
        jp      INSTR_35_GOTO

;===============================================================
; INSTRUCAO "IF REG($)<$ GOTO @" 
;===============================================================
INSTR_14_IF_REG_LOWER:
        call    COMPARA_REG_COM_PROX_BYTE
        inc     c
        cp      c
        jr      c,CARREGA_PROX_BYTE_INSTR
        jr      GOTO_PROX_BYTE_INSTR

;===============================================================
; INSTRUCAO "IF OBJ($) IS_NEARBY GOTO @" 
;===============================================================
INSTR_15_IF_OBJ_NEARBY:
        call    TROCA_OBJ_ZERO_POR_EVID
        call    CARREGA_POS_OBJ         ; posicao atual do objeto
        cp      $fb                     ; objeto no container?
        jr      nz,IF_OBJ_NO_LOCAL
        ld      a,(TABELA_POS_OBJS+3)   ; posicao atual do container
        cp      $fa                     ; container com jogador?
        jr      z,GOTO_PROX_BYTE_INSTR
IF_OBJ_NO_LOCAL:
        ld      hl,REG01_POS_ATUAL
        cp      (hl)                    ; objeto no local?
        jr      z,GOTO_PROX_BYTE_INSTR
        sub     100
        cp      (hl)                    ; objeto escondido no local?
IF_Z_GOTO:
        jr      z,GOTO_PROX_BYTE_INSTR
CARREGA_PROX_BYTE_INSTR:
        ex      de,hl
        ld      hl,(END_PROX_BYTE)
        ld      a,(hl)
        inc     hl
        jp      UPDATE_PROX_BYTE_INSTR

;===============================================================
; INSTRUCAO "IF AT POS($) GOTO @" 
;===============================================================
INSTR_16_IF_AT_POS:
        ld      a,(REG01_POS_ATUAL)
        cp      c
        jr      IF_Z_GOTO

;===============================================================
; INSTRUCAO "IF HAVE OBJ($) GOTO @" 
;===============================================================
INSTR_17_IF_HAVE_OBJ:
        call    TROCA_OBJ_ZERO_POR_EVID
        call    CARREGA_POS_OBJ
        cp      $fa
        jr      IF_Z_GOTO

;===============================================================
; INSTRUCAO "DROP OBJ($)" 
;===============================================================
INSTR_18_DROP_OBJ:
        call    TROCA_OBJ_ZERO_POR_EVID
        cp      100
        jr      z,DROP_ALL_OBJS
        call    CARREGA_POS_OBJ
        ld      a,(REG01_POS_ATUAL)
        ld      (hl),a
        ld      hl,REG08_CONTADOR_OBJS_JOGADOR
        dec     (hl)
        ret
DROP_ALL_OBJS:
        ld      hl,REG08_CONTADOR_OBJS_JOGADOR
        ld      c,$fa
DROP_OBJS_FROM_C:
        ld      (hl),d
        ld      hl,TABELA_POS_OBJS
DROP_OBJS_LOOP:
        inc     hl
        ld      a,(hl)
        cp      $ff
        ret     z
        cp      c
        jr      nz,DROP_OBJS_LOOP
        ld      a,(REG01_POS_ATUAL)
        ld      (hl),a
        jr      DROP_OBJS_LOOP

;===============================================================
; INSTRUCAO "GET OBJ($)" 
;===============================================================
INSTR_19_GET_OBJ:
        call    TROCA_OBJ_ZERO_POR_EVID
        ld      e,a
        ld      a,(MAX_OBJS_JOGADOR)
        dec     a
        ld      hl,REG08_CONTADOR_OBJS_JOGADOR
        cp      (hl)
        jr      nc,GET_OBJ
        ld      a,20                    ; MSG(20) = "Sinto muito mas nao da para carregar mais nada."
PRINT_MSG_AND_EXIT:
        ld      hl,(END_TABELA_MENSAGENS)
        call    BUSCA_N_ESIMO
        jp      PRINT_STRING_AND_EXIT
GET_OBJ:
        inc     (hl)
        ld      hl,TABELA_POS_OBJS
        add     hl,de
        ld      a,(hl)
        ld      (hl),$fa
        cp      $fb
        ret     nz
        ld      hl,REG07_CONTADOR_OBJS_CONTAINER
        dec     (hl)
        ret

;===============================================================
; INSTRUCAO "CREATE OBJ($)" 
;===============================================================
INSTR_20_CREATE_OBJ:
        call    TROCA_OBJ_ZERO_POR_EVID
        call    CARREGA_POS_OBJ
        ld      a,(REG01_POS_ATUAL)
        ld      (hl),a
        ret

;===============================================================
; INSTRUCAO "BREAK OBJ($)" 
;===============================================================
INSTR_21_BREAK_OBJ:
        call    TROCA_OBJ_ZERO_POR_EVID
        call    CARREGA_POS_OBJ
        ld      (hl),b
        cp      $fa
        ld      hl,REG07_CONTADOR_OBJS_CONTAINER
        jr      z,PERDE_OBJ
        cp      $fb
        ret     nz
        dec     (hl)
        ret
PERDE_OBJ:
        inc     hl
        dec     (hl)
        ret

;===============================================================
; INSTRUCAO "EXEC FUNC($)" 
;===============================================================
INSTR_22_EXEC_FUNC:
        ld      hl,(END_PRIMEIRO_BYTE)
        ld      (END_RETORNO_PRIMEIRO_BYTE),hl
        ld      hl,(END_PROX_BYTE)
        ld      (END_RETORNO_PROX_BYTE),hl
        ld      hl,(END_TABELA_FUNCOES)
        call    BUSCA_N_ESIMO
UPDATE_PRIM_E_PROX_BYTE_INSTR:
        ld      (END_PRIMEIRO_BYTE),hl
UPDATE_PROX_BYTE_INSTR:
        ld      (END_PROX_BYTE),hl
        ret

;===============================================================
; INSTRUCAO "OPEN CONTAINER" 
;===============================================================
INSTR_23_OPEN_CONTAINER:
        ld      c,$fd
        ld      b,$fb
MUDA_CONTAINER:
        ld      hl,TABELA_POS_OBJS
MUDA_CONTAINER_LOOP:
        inc     hl
        ld      a,(hl)
        cp      $ff
        jp      z,INSTR_00_NOP
        cp      c
        jr      nz,MUDA_CONTAINER_LOOP
        ld      (hl),b
        jr      MUDA_CONTAINER_LOOP

;===============================================================
; INSTRUCAO "CLOSE CONTAINER"
;===============================================================
INSTR_24_CLOSE_CONTAINER:
        ld      c,$fb
        ld      b,$fd
        jr      MUDA_CONTAINER

;===============================================================
; INSTRUCAO "PUT OBJ($) INTO_CONTAINER" 
;===============================================================
INSTR_25_PUT_OBJ_CONTAINER:
        call    TROCA_OBJ_ZERO_POR_EVID
        ld      a,(MAX_OBJS_CONTAINER)
        dec     a
        ld      hl,REG07_CONTADOR_OBJS_CONTAINER
        cp      (hl)
        jr      nc,PUT_OBJ
        ld      a,21                    ; MSG(21) = "A sacola esta completamente cheia."
        jp      PRINT_MSG_AND_EXIT
PUT_OBJ:
        ld      a,c
        inc     (hl)
        call    CARREGA_POS_OBJ
        ld      (hl),$fb
        ret

;===============================================================
; INSTRUCAO "DROP ALL_FROM_CONTAINER" 
;===============================================================
INSTR_26_DROP_ALL_CONTAINER:
        call    INSTR_00_NOP
        ld      hl,REG07_CONTADOR_OBJS_CONTAINER
        ld      c,$fb
        jp      DROP_OBJS_FROM_C

;===============================================================
; INSTRUCAO "EXIT OK" 
;===============================================================
INSTR_27_EXIT_OK:
        ld      hl,MSG_OK
        jp      PRINT_STRING_AND_EXIT

;===============================================================
; INSTRUCAO "PRINT REG($)" 
;===============================================================
INSTR_28_PRINT_REG:
        call    LOCALIZA_REG
        ld      l,(hl)
        ld      h,b

; funcao generica para impressao de HL como valor decimal na tela
PRINT_NUMERO:
        ld      a,h
        or      l
        jr      nz,PRINT_NUMERO_POSITIVO
        ld      a,'0'
        jp      INSTR_41_PRINT_CHRS
PRINT_NUMERO_POSITIVO:
        ld      de,TABELA_DIGITOS
        xor     a
        ld      (CONTADOR_GENERICO),a
CARREGA_DIGITO:
        ex      de,hl
        ld      c,(hl)
        inc     hl
        ld      b,(hl)
        inc     hl
        ex      de,hl
        xor     a
DIVIDE_DIGITO_LOOP:
        inc     a
        sbc     hl,bc
        jr      nc,DIVIDE_DIGITO_LOOP
        add     hl,bc
        dec     a
        jr      nz,PRINT_DIGITO
        ld      a,(CONTADOR_GENERICO)
        or      a
        jr      z,CARREGA_DIGITO
        xor     a
PRINT_DIGITO:
        add     a,'0'
        ld      (CONTADOR_GENERICO),a
        push    de
        call    INSTR_41_PRINT_CHRS
        pop     de
        dec     c
        jr      nz,CARREGA_DIGITO
        ret

;===============================================================
; INSTRUCAO "EXIT FROM_FUNC5" 
;===============================================================
INSTR_29_EXIT_FUNC5:
        ld      hl,PROX_COMANDO_APOS_FUNC5
        jr      INTERROMPE_INSTR

;===============================================================
; INSTRUCAO "EXIT FROM_FUNC4"
;===============================================================
INSTR_30_EXIT_FUNC4:
        pop     hl
        ret

;===============================================================
; INSTRUCAO "EXIT QUIT_GAME" 
;===============================================================
INSTR_31_EXIT_QUIT:
        call    APAGA_INPUT
        call    ESPERA_TECLA
        and     $df
        cp      'S'
        jr      z,INSTR_32_EXIT_RESTART
        cp      'N'
        jr      nz,INSTR_31_EXIT_QUIT
        rst     $00

;===============================================================
; INSTRUCAO "EXIT RESTART_GAME" 
;===============================================================
INSTR_32_EXIT_RESTART:
        ld      hl,MOSTRA_TELA_ABERTURA
        jr      INTERROMPE_INSTR

;===============================================================
; INSTRUCAO "EXIT DESC" 
;===============================================================
INSTR_33_EXIT_DESC:
        ld      hl,COMANDO_DESC
INTERROMPE_INSTR:
        ld      a,$ff
        ld      (INTERROMPER_INTERPRETADOR),a
        ret

;===============================================================
; INSTRUCAO "RETURN" 
;===============================================================
INSTR_34_RETURN:
        ld      hl,(END_RETORNO_PRIMEIRO_BYTE)
        ld      (END_PRIMEIRO_BYTE),hl
        ld      hl,(END_RETORNO_PROX_BYTE)
JUMP_UPDATE_PROX_BYTE_INSTR:
        jp      UPDATE_PROX_BYTE_INSTR

;===============================================================
; INSTRUCAO "GOTO @"
;===============================================================
INSTR_35_GOTO:
        add     a,20
        ld      c,a
        ld      hl,(END_PRIMEIRO_BYTE)
BUSCA_GOTO_LABEL:
        ld      a,(hl)
        inc     hl
        cp      $fc
        jp      z,INSTR_02_EXIT
        cp      c
        jr      nz,BUSCA_GOTO_LABEL
        jr      JUMP_UPDATE_PROX_BYTE_INSTR

;===============================================================
; INSTRUCAO "PAUSE $"
;===============================================================
INSTR_36_PAUSE:
        inc     a
        ld      e,a
PAUSE_LOOP:
        ld      bc,60                   ; PAUSE 60 ticks (1 segundo no TK em 60Hz)
        call    $1f3d
        dec     e
        jr      nz,PAUSE_LOOP
        ret

;===============================================================
; INSTRUCAO "FLAG($):=$" 
;===============================================================
INSTR_37_SET_FLAG:
        ld      hl,FLAG_0_ESCURIDAO
        add     hl,bc
        call    CARREGA_PROX_BYTE_INSTR
        ld      (de),a
        ret

;===============================================================
; INSTRUCAO "OBJ(EVID):=PARAM($)" 
;===============================================================
INSTR_38_SET_EVID:
        ld      hl,OBJ1_ATUAL
        dec     a
        jr      z,SET_EVID_OBJ1
        inc     hl
SET_EVID_OBJ1:
        ld      a,(hl)
        ld      (OBJ_EVID),a
        ret

;===============================================================
; INSTRUCAO "CLS"
;===============================================================
INSTR_39_CLS:
        call    INSTR_00_NOP

APAGA_RESPOSTA:
        ld      c,2
APAGA_LINHA:
        ld      a,c
        cp      21
        jp      z,SETA_COORD_RESPOSTA
        call    $0e9e                   ; converte linha A em coordenada na tela
APAGA_SUBLINHA:
        xor     a
        push    hl
        ld      b,32
APAGA_BYTE:
        ld      (hl),a
        inc     l
        djnz    APAGA_BYTE
        pop     hl
        inc     h
        ld      a,h
        and     7
        jr      nz,APAGA_SUBLINHA
        inc     c
        jr      APAGA_LINHA

;===============================================================
; INSTRUCAO "IF OBJ(EVID)=OBJ($) GOTO @" 
;===============================================================
INSTR_40_IF_EVID_OBJ:
        ld      a,(OBJ_EVID)
        cp      c
JUMP_IF_Z_GOTO:
        jp      IF_Z_GOTO

;===============================================================
; INSTRUCAO "PRINT CHRS($)"
;===============================================================
INSTR_41_PRINT_CHRS:
        ld      d,a
        ld      a,(FLAG_0_ESCURIDAO)
        or      a
        ld      a,d
        ret     nz
        jr      PRINT40

;===============================================================
; INSTRUCAO "EXIT MSG($)+OBJ($)" 
;===============================================================
INSTR_42_EXIT_MSG_OBJ:
        call    INSTR_01_PRINT_MSG
        call    CARREGA_PROX_BYTE_INSTR
        call    INSTR_06_PRINT_OBJ
        ld      a,'.'
        call    INSTR_41_PRINT_CHRS
        jp      INSTR_02_EXIT

;===============================================================
; INSTRUCAO "IF OBJ($) INSIDE_CONTAINER GOTO @" 
;===============================================================
INSTR_43_IF_OBJ_INSIDE:
        call    TROCA_OBJ_ZERO_POR_EVID
        call    CARREGA_POS_OBJ
        ld      a,(hl)
        cp      $fb
        jr      JUMP_IF_Z_GOTO

;===============================================================
; INSTRUCAO "EXEC CMD($)" 
;===============================================================
INSTR_44_EXEC_CMD:
        ld      hl,(END_TABELA_COMANDOS)
        call    BUSCA_N_ESIMO
        inc     hl
        inc     hl
        inc     hl
        jp      UPDATE_PRIM_E_PROX_BYTE_INSTR

;===============================================================
; INSTRUCAO "WAIT KEY"
;===============================================================
INSTR_45_WAIT_KEY:
        call    INSTR_00_NOP
ESPERA_TECLA:
        ld      hl,$5c08                ; LASTK (ultima tecla pressionada)
        xor     a
        ld      (hl),a                  ; zera leitura de teclas
ESPERA_TECLA_LOOP:
        or      (hl)                    ; alguma tecla foi pressionada?
        jr      z,ESPERA_TECLA_LOOP
        ret

;===============================================================
; DESENHA TELA DE JOGO
;===============================================================
DESENHA_TELA_TEXTO:
        call    $0daf                   ; executa rotina CL-ALL (clear screen)
        ld      a,$18                   ; marcador de inicio de comando
        ld      hl,$0002                ; PRINT AT 0,2;
        call    PRINTAT40
        call    PRINT40
        ld      hl,$1702                ; PRINT AT 23,2;
        call    PRINTAT40
        call    PRINT40
        ld      a,$1b
        ld      hl,$0102                ; PRINT AT 1,2;
        call    PREENCHE_TRECHO
        ld      a,$1a
        ld      hl,$1602                ; PRINT AT 22,2;
        call    PREENCHE_TRECHO
SETA_COORD_RESPOSTA:
        ld      hl,(COORD_RESPOSTA)

;===============================================================
; ROTINA PARA POSICIONAR CURSOR NA TELA EM 40 COLUNAS
; Funciona como um comando "PRINT AT H,L;" em modo texto 40x24
; H=linha (0 a 23)
; L=coluna (0 a 39)
;===============================================================
PRINTAT40:
        push    af
        ld      a,h
        ld      (ROW40),a
; converte coluna em coordenada hi-res, ou seja, A=L*6+9
        ld      a,l
        add     a,a
        add     a,l
        add     a,a
        add     a,9
        ld      (COL40),a
        pop     af
        ret

;===============================================================
; ROTINA PARA IMPRESSAO EM 40 COLUNAS
; Simula o modo texto 40x24 usado no SERRA PELADA para MSX
;===============================================================
PRINT40:
        push    af
        push    hl
        push    bc
        push    de
        ld      hl,COL40
        cp      13
        jr      z,NEWLINE40
        cp      6
        jr      nz,PRINTCHAR40
        ld      (hl),14*6+9             ; PRINT 'TAB 14;
        jr      NEXTROW40
PRINTCHAR40:
        ld      e,(hl)                  ; E=coluna
        ld      h,31                    ; H="valor base" da tabela de caracteres
        ld      l,a                     ; L=caracter
        add     hl, hl
        add     hl, hl
        add     hl, hl                  ; HL = "valor base" * 2048 + caracter * 8

        ld      a,(ROW40)               ; A=linha
        cp      24
        jr      nc,EXIT40               ; ignora impressao fora da tela

        push    hl                      ; guarda endereco na tabela de caracteres
        call    $0e9e                   ; converte linha A em coordenada na tela
        ld      a,e                     ; A=coluna
        ld      d,0
        srl     e
        srl     e
        srl     e                       ; DE=coluna/8
        add     hl, de                  ; HL = endereco da linha+coluna na tela
        pop     de
        and     7
        ld      c,a                     ; C=deslocamento horizontal do caracter (3 bits menos significativos da coluna)
LOOP40:
        ld      a,(de)
        and     $fc
        push    de
        ld      e,a                     ; lado esquerdo da imagem do caracter
        xor     a                       ; mascara para impressao do caracter
        ld      d,a                     ; lado direito da imagem do caracter
        ld      b,c
ROTATE40:
        srl     e                       ; desloca imagem do caracter de acordo com coluna na tela
        rr      d
        scf
        rra                             ; desloca mascara do caracter
        djnz    ROTATE40
        and     (hl)                    ; apaga conteudo anterior da tela usando mascara
        or      e
        ld      (hl),a                  ; substitui conteudo anterior por lado esquerdo da imagem do caracter (usando mascara)
        inc     hl
        ld      (hl),d                  ; substitui conteudo anterior por lado direito da imagem do caracter (sem mascara)
        dec     hl
        pop     de
        inc     de
        inc     h
        ld      a,h
        and     7
        jr      nz,LOOP40
        ld      hl,COL40
        ld      a,(hl)
        add     a,6
        ld      (hl),a
        cp      248
        jr      c,EXIT40
NEWLINE40:
        ld      (hl),9
NEXTROW40:
        inc     hl                      ; HL = endereco de ROW40
        inc     (hl)                    ; proxima linha
EXIT40:
        pop     de
        pop     bc
        pop     hl
        pop     af
        ret

;===============================================================
; TABELA DE DIGITOS DECIMAIS USADA PARA IMPRIMIR VALORES NA TELA
;===============================================================
TABELA_DIGITOS:
        defw    10000
        defw    1000
        defw    100
        defw    10
        defw    1

;===============================================================
; TABELA DE ACENTOS, MAPEIA NUMEROS EM CARACTERES ACENTUADOS
;===============================================================
; Tabela de conversao de teclas numericas digitadas em caracteres acentuados
TABELA_ACENTOS:
        defb    '1', $84                ; aacute
        defb    '2', $90                ; eacute
        defb    '3', $89                ; iacute
        defb    '4', $8a                ; oacute
        defb    '5', $8c                ; acirc
        defb    '6', $8d                ; ecirc
        defb    '7', $8e                ; ocirc
        defb    '8', $80                ; ccedil
        defb    '9', $b0                ; atilde
        defb    '0', $b4                ; otilde
        defb    $00

;===============================================================
; MENSAGENS USADAS DIRETAMENTE PELO PROGRAMA (NAO CONFIGURAVEIS)
;===============================================================
MSG_NESTE_LOCAL_TEM:
        defm    "Neste local tem:", $fc
MSG_NADA_INTERESSANTE:
        defm    "nada interessante.", $fc
MSG_NOS_TEMOS:
        defm    "N",$a2,"s temos:", $fc
MSG_OK:
        defm    "Ok.", $fc
MSG_GRAVANDO:
        defm    "Gravando... ", $fc
MSG_CARREGANDO:
        defm    "Carregando... ", $fc
MSG_ERRO:
        defm    "  * ERRO *", $fc

;===============================================================
; Imagem da mensagem "PRESSIONE ENTER"
; Reaproveita a area de variaveis (registradores e posicoes) p/
; armazenar a imagem, uma vez que essa imagem so' e' necessaria
; na entrada do jogo, e logo em seguida a area de variaveis e'
; zerada de qualquer jeito.
;===============================================================
        org     TABELA_POS_OBJS-12
IMG_ENTER:
        defb    $07, $87, $87, $c3, $83, $83, $83, $84
        defb    $47, $c0, $07, $c4, $47, $c7, $c7, $80
        defb    $04, $44, $44, $04, $44, $41, $04, $46
        defb    $44, $00, $04, $06, $41, $04, $04, $40
        defb    $04, $44, $44, $04, $04, $01, $04, $46
        defb    $44, $00, $04, $06, $41, $04, $04, $40
        defb    $07, $87, $87, $83, $83, $81, $04, $45
        defb    $47, $80, $07, $85, $41, $07, $87, $80
        defb    $04, $05, $04, $00, $40, $41, $04, $44
        defb    $c4, $00, $04, $04, $c1, $04, $05, $00
        defb    $04, $04, $84, $04, $44, $41, $04, $44
        defb    $c4, $00, $04, $04, $c1, $04, $04, $80
        defb    $04, $04, $47, $c3, $83, $83, $83, $84
        defb    $47, $c0, $07, $c4, $41, $07, $c4, $40

;===============================================================
; FIM!
;===============================================================
